<?php
/**
 * Implementation of hook_form().
 */
function family_group_form(&$node) {
  $form['title'] = array(
    '#type' => 'hidden',
    '#default_value' => $node->NAME,
  );
  $form['MARR']['MARR_TYPE'] = array(
    '#type' => 'select',
    '#title' => t('Type of Union'),
    '#default_value' => $node->MARR_TYPE,
    '#options' => array(
      'Unmarried' => 'Unmarried',
      'Religious' => 'Religious',
  );
  $form['MARR']['MARR_DATE'] = array(
    '#type' => 'textfield',
    '#title' => t('Date of Union'),
    '#description'=>t('Year-Month-Day YYYY-MM-DD'),
    '#default_value' => $node->MARR_DATE,
  );
  $form['MARR']['MARR_PLAC'] = array(
    '#type' => 'textfield',
    '#title' => t('Place of Union'),
    '#default_value' => $node->MARR_PLAC,
  );
  $form['MARR']['DIV_DATE'] = array(
    '#type' => 'textfield',
    '#title' => t('Date of Separation'),
    '#description'=>t('Year-Month-Day YYYY-MM-DD'),
    '#default_value' => $node->DIV_DATE,
  );
  $form['MARR']['DIV_PLAC'] = array(
    '#type' => 'textfield',
    '#title' => t('Place of Separation'),
    '#default_value' => $node->DIV_PLAC,
  );
  $parents=array();
  $indivs=db_query('SELECT nid, title_format FROM {family_individual}');
  while($data = mysql_fetch_array($indivs)){
  $parents[$data['nid']]=$data['title_format'];
  }
  $form['PAR1'] = array(
    '#type' => 'select',
    '#title' => t('Parent 1'),
    '#default_value' => $node->PAR1,
    '#options'=> array('' => 'Unknown', 'Individuals'=>$parents),
	'#description'=>t('The parent whose last name is carried by the children.'),
  );
  $form['PAR1'] = array(
    '#type' => 'select',
    '#title' => t('Parent 2'),
    '#default_value' => $node->PAR2,
    '#options'=> array('' => 'Unknown', 'Individuals'=>$parents),
  );
  $form['body_filter']['body'] = array(
    '#type' => 'textarea',
    '#title' => t('Biography'),
    '#default_value' => $node->body,
    '#rows' => 20,
    '#required' => FALSE,
    '#weight' => 2
  );
  $form['body_filter']['format'] = filter_form($node->format); //Not sure why this goes here, but all the examples have it...
  return $form;
} // function family_group_form(&$node, &$param)

/**
 * Implementation of hook_insert().
 */
function family_group_insert($node) {
  $node->title = $node->'The Family of '.$node->PAR1.' & '.node->PAR2;
  db_query("INSERT INTO {family_group} (vid, nid, title_format, marr_type, marr_date, marr_plac, div_date, div_plac, parent1, parent2) VALUES (%d, ,%d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')", 
  $node->vid, $node->nid, $node->NAME, $node->MARR_TYPE, $node->MARR_DATE, $node->MARR_PLAC, $node->DIV_DATE,$node->DIV_PLAC, $node->PAR1, $node->PAR2);
} //function family_group_form()

/**
 * Implementation of hook_load().
 */
function family_group_load($node) {
  $additions = db_fetch_object(db_query('SELECT * FROM {family_group} WHERE nid = %d', $node->nid));
  return $additions;
} //function family_group_load()

/**
 * Implementation of hook_update().
 */
function family_group_update($node) {
  $node->title = $node->'The Family of '.$node->PAR1.' & '.node->PAR2;
  // if this is a new node or we're adding a new revision,
  if ($node->revision) {
    family_group_insert($node);
  }
  else {
    db_query("UPDATE {family_group} SET title_format='%s', marr_type='%s', marr_date='%s', marr_plac='%s', div_date='%s', div_plac='%s', parent1='%s', parent2='%s' WHERE nid='%d'", 
  $node->NAME, $node->MARR_TYPE, $node->MARR_DATE, $node->MARR_PLAC, $node->DIV_DATE, $node->DIV_PLAC,$node->PAR1, $node->PAR2, $node->nid);
} //function family_group_update()

/**
 * Implementation of hook_view().
 */
function family_group_view(&$node, $teaser = FALSE, $page = FALSE) {
  $node = node_prepare($node, $teaser);
  $node->content['family_group_view'] = array(
      '#value' => theme($teaser? 'family_group_teaser':'family_group_body', $node),
      '#weight' => -1,
  );
  return $node;
} //function family_group_view()

function theme_family_group_teaser($node) {
  return family_view_group($node->nid,$type=0);
}
function theme_family_group_body($node) {
  return family_view_group($node->nid,$type=1);
}

/**
 * Implementation of hook_delete().
 */
function family_group_delete(&$node) {
  db_query('DELETE FROM {family_group} WHERE nid = %d', $node->nid);
} //function family_group_delete